org.apache.tinkerpop.gremlin.process.traversal.step.filter

## Class HasStep<S extends Element>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,S>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.filter.FilterStep<S>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.filter.HasStep<S>

- All Implemented Interfaces:
    Serializable, Cloneable, Iterator<Traverser.Admin<S>>, Step<S,S>, HasContainerHolder

      public class HasStep<S extends Element>
      extends FilterStep<S>
      implements HasContainerHolder

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HasStep(Traversal.Admin traversal, HasContainer... hasContainers)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addHasContainer(HasContainer hasContainer)`
    `HasStep<S>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `protected boolean` | `filter(Traverser.Admin<S> traverser)`
    `List<HasContainer>` | `getHasContainers()`
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `int` | `hashCode()`
    `void` | `removeHasContainer(HasContainer hasContainer)`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.filter.FilterStep

      `processNextStart`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getTraversal, hasNext, next, removeLabel, reset, setId, setNextStep, setPreviousStep, setTraversal`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### HasStep

          public HasStep(Traversal.Admin traversal,
                         HasContainer... hasContainers)

  - ### Method Detail

    - #### filter

          protected boolean filter(Traverser.Admin<S> traverser)

      Specified by:
        `filter` in class `FilterStep<S extends Element>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S extends Element,S extends Element>`

    - #### getHasContainers

          public List<HasContainer> getHasContainers()

      Specified by:
        `getHasContainers` in interface `HasContainerHolder`

    - #### removeHasContainer

          public void removeHasContainer(HasContainer hasContainer)

      Specified by:
        `removeHasContainer` in interface `HasContainerHolder`

    - #### addHasContainer

          public void addHasContainer(HasContainer hasContainer)

      Specified by:
        `addHasContainer` in interface `HasContainerHolder`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S extends Element,S extends Element>`
      Returns:
        the set of requirements

    - #### clone

          public HasStep<S> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S extends Element,S extends Element>`
      Overrides:
        `clone` in class `AbstractStep<S extends Element,S extends Element>`
      Returns:
        The cloned step

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S extends Element,S extends Element>`

Copyright © 2013–2020 Apache Software Foundation. All rights reserved.